<%-- This JSP is used for rendering the report --%>

<%@ page language="java" contentType="text/html; charset=UTF-8"%>
<%@ page errorPage="BloxError.jsp" %>

<%@ taglib uri="resourcetagstld" prefix="res" %>

<%@ taglib uri="bloxtld" prefix="blox" %> 
<%@ taglib uri="bloxreporttld" prefix="bloxreport" %>
<%@ taglib uri="http://java.sun.com/jsp/jstl/core" prefix="c"%>

<%@ page import="com.ibm.scm.reports.*"%>
<%@ page import="com.ibm.scm.reports.sql.*"%>
<%@ page import="com.ibm.scm.reports.filtering.*"%>
<%@ page import="com.alphablox.blox.*" %>
<%@ page import="java.util.*"%>

<!--
  
   @(#)97  1.8  src/web/reports/report.jsp, hc.report, scm5110, 070105a  1/5/07  04:09:43   
  
   Licensed Materials - Property of IBM
   5724-F82
   (C) Copyright IBM Corp.  2003, 2006
   All Rights Reserved
   US Government Users Restricted Rights - Use, duplication or 
   disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
  
-->

<res:checkUser />

<%	
	// Get the requested report information
	String reportName = request.getParameter("report"); 
	String reportId = request.getParameter("reportId");
	String renderer = request.getParameter("render");
	
	boolean isPrinterRenderer = false;
	if (renderer != null && renderer.equals("printer")) 
		isPrinterRenderer = true;

	boolean isRefreshed = false;
	String refreshParam = request.getParameter("refresh");
	if (refreshParam != null && refreshParam.equals("true"))
		isRefreshed = true;

	
	// Refresh the report ?
	if (isRefreshed && reportId != null) {
		ReportsFactory.reloadReport(Integer.parseInt(reportId), this.getServletContext());
	}
	
	
	// Get the report, according to request
	ReportBean report=null;
	if (reportName == null && reportId == null) 
		throw new Exception("Report name cannot be empty");

	if (reportName != null) {
		// Load the new report instance, basing on its name
		report = ReportsFactory.loadReport(reportName, this.getServletContext());
		if (report == null)
			throw new Exception("Cannot load report: "+reportName);
	} else if (reportId != null) {
		// Load a previously loaded report instance, basing on its unique id
		report = ReportsFactory.getPreviouslyLoadedReport(Integer.parseInt(reportId));
		if (report == null)
			throw new Exception("Cannot load report with ID: "+reportId);
	}

	// Get the blox context...
	BloxContext bContext = BloxContextFactory.getBloxContext(request, response);
	
	// If the report has no data, then let's refresh it, just in case
	// new data were created meanwhile
	if (!report.hasAnyData(bContext)) {
		ReportsFactory.reloadReport(report.getId(), this.getServletContext());
	} 
	
	// Check whether this report is not supposed for printing...
	pageContext.setAttribute("isPrintRenderer", new Boolean(isPrinterRenderer));

	pageContext.setAttribute("bloxes", report.getBloxes());
 %>

<html xmlns="http://www.w3.org/1999/xhtml">

<head>

	<c:if test="${!isPrintRenderer}">
	 	<link rel="stylesheet" href="res/report.css" /> 
	 </c:if>
	 <c:if test="${isPrintRenderer}">
	 	<link rel="stylesheet" href="res/reportPrinter.css" /> 
	 </c:if>
	 	
	<blox:header/>

	<meta http-equiv="Content-Type" content="text/html; charset=UTF-8" />
	<title><%=report.getTranslatedTitle()%></title>

	<script language="JavaScript" src="res/navigationHelpers.js" ></script>
	<script language="JavaScript" src="res/reportsHelpers.jsp" ></script>
</head>

<body>

<%-- A "request IFrame" --%>
<iframe id='reqFrame' name='reqFrame' src="blank.html" style="width:0px; height:0px; border: 0px"></iframe>


<%--------------------------------------------------------%>
<%-- Render the report.        						    --%>
<%--------------------------------------------------------%>


<%-- Title  --%>
<a name="<%=report.getLinkId() %>" class="linkname"></a>
<table border="0" cellspacing="0" cellpadding="0" width="96%">
	<tr>

		<td>
			<h1 id="reportTitleH1"><%=report.getTranslatedName()%></h1>
		</td>

		<td align="right" valign="middle">
			<%-- Print and refresh options --%>
			<c:if test="${!isPrintRenderer}">
				<span class="button">
					<a href="<%=LinkFactory.getReportRefresh(report)%>">
						<img src="res/toolbar_refresh.gif" />
						<res:t id="refresh-this-report"/>
					</a>
				</span>
				<span class="button">
					<a href="<%=LinkFactory.getReportPrint(report)%>" target="_blank">
						<img src="res/print.gif" />
						<res:t id="print-this-report"/>
					</a>
				</span>
			</c:if>
		</td>

	</tr>
</table>


<%-- Report description --%>
<table border="0" cellspacing="0" cellpadding="0">
	<tr>
		<td class="default"><b><res:t id="description"/></b></td>
		<td width="10px"></td>
		<td class="default"><%=report.getTranslatedDescription()%></td>
	</tr>
	<tr height="10px"></tr>
	<tr>
		<td class="default"><b><res:t id="report-date"/></b></td>
		<td width="10px"></td>
		<td class="default"><%= new java.util.Date() %></td>
	</tr>
</table>
<br/>





<c:forEach items="${bloxes}" var="blox">

	<a name="${blox.linkId}" class="linkname"> </a>
	<%-- <h2><%=blox.getTitle()%></h2> --%>

	<% 
		// Set the page attributes for further evaulation with el
		AbstractBloxBean blox = (AbstractBloxBean) pageContext.getAttribute("blox");

		String bloxType = null;
		if (blox.getBloxType() == AbstractBloxBean.BLOX_RELATIONAL_REPORT) {
			bloxType = "RELATIONAL_REPORT";
		} else if (blox.getBloxType() == AbstractBloxBean.BLOX_CHART) {
			bloxType = "CHART";
		}
		pageContext.setAttribute("bloxtype", bloxType);
		
		
	%>

	<c:choose>



		<%-- ------------------------ --%>
		<%--  Relational Report Blox  --%>
		<%-- ------------------------ --%>
		<c:when  test="${bloxtype == 'RELATIONAL_REPORT'}">



		<%
			ReportBloxBean relationalBloxBean = (ReportBloxBean) blox;

			try {

				// Get initial options (sent via forwardLink) - only one is possible
				HashMap initialFilters = relationalBloxBean.setInitialFilters(request);
		
				// Create the bloxes itself
				PagedSQLDataBlox pgd;
				ReportBlox rBlox;
				
				// Check if blox with given id already exists....
				String bID = relationalBloxBean.getId();			
				rBlox = (ReportBlox) bContext.getBlox(bID);
				pgd = (PagedSQLDataBlox) bContext.getBlox(relationalBloxBean.getPagedSQLDataBloxID());

			
				// If both bloxes haven't been yet initialized, create them
				if (rBlox == null || pgd == null) {
						
					pgd = relationalBloxBean.createPagedSQLDataBlox(bContext);
					rBlox = relationalBloxBean.createReportBlox(bContext, pgd, report);

					String bloxName = rBlox.getBloxName();
					if (bloxName == null) {
						bloxName = rBlox.getId();
					}
					rBlox.init(bContext, bloxName);		
				} else {
					// If they already have been initialized, then let's reload the data
					// (in case they have changed.... stupid AlphaBlox (see defect 74535)
					pgd.refresh();
				}
			

				// Render the drill-down (forwardLink) info
				if (!isPrinterRenderer) {
					out.println(relationalBloxBean.getForwardLinksMessage());
				}

				// Render the filter options
				if (relationalBloxBean.getFilterOptions().size() > 0) {
					RenderFOs rfo = new RenderFOs(rBlox, pgd, initialFilters);
					rfo.render(pageContext.getOut(), "setQueryDynamically.jsp", "reqFrame", true);
				}

				// Paging
				//
				int pagesCount = pgd.getLastPageNumber();
				int currentPage = pgd.getCurrentPage();
		
			%>

<div id="paging" class="pagingBar">
<table width='100%'>
<tr>
<td nowrap>
	<b><res:t id='pages'/></b>
	<a onClick="setPageNumber('<%=rBlox.getBloxName() %>', '<%=pgd.getBloxName() %>', 'prev');return false;" href="#">
			<img src='res/base/icon_back.gif' style="vertical-align: text-bottom;" border='0' />
			<res:t id="prev-page"/>
	</a> 
	| 
	<res:t id="go-to-page"/>
		<select name="pageNumber" id="pageNumber" onchange="onPagesComboChange('<%=rBlox.getBloxName() %>','<%=pgd.getBloxName() %>');return false;">
		</select>
	| 
	<a onClick="setPageNumber('<%=rBlox.getBloxName() %>', '<%=pgd.getBloxName() %>', 'next'); return false;" href="#">
		<res:t id="next-page" />
		<img src='res/base/icon_forward.gif' style="vertical-align: text-bottom;" border='0' />
	</a> 
	|
	<span id="pageNumberStatus"></span>
	|
	<res:t id="rows-per-page" />
			<script type="text/javascript">
				function onChangeRowsPerPage(selectObj) {
					if (selectObj.selectedIndex <= 0)
						return false;
					optionObj=selectObj.options[selectObj.selectedIndex];
					setRowsPerPage('<%=rBlox.getBloxName()%>','<%=pgd.getBloxName()%>',optionObj.value);
				}
			</script>
			<select name="rowsPerPageNumber" onChange="onChangeRowsPerPage(this); return false;">
			<%
				for (int i = 0; i < PagedSQLDataBlox.VALID_ROWS_PER_PAGE_LIMITS.length; i++) {
					int rowsPerPage = PagedSQLDataBlox.VALID_ROWS_PER_PAGE_LIMITS[i];
					String selectedStr = "";
					if (rowsPerPage == pgd.getRowsPerPage())
						selectedStr = "selected='true' ";
					
					out.println(
						"<option "+
							selectedStr+
						//	"onClick=\"javascript:setRowsPerPage('"+rBlox.getBloxName()+"','"+pgd.getBloxName()+"','"+rowsPerPage+"'); return false;\""+ 
							"value="+rowsPerPage+
						 ">"+
							rowsPerPage+
						"</option>");
				}						
			 %>
		</select>

	<span id="filtersApplyWarningSeparator"></span>
	<span id="filtersApplyWarning" style="font-weight: bold; color: gray;"></span>

</td>

<td align="right" nowrap>
			<c:if test="${!isPrintRenderer}">

				<a href="<%=LinkFactory.getReportBloxToPDF(report,blox)%>" >
					<img src="res/base/icon_pdf.gif" style="vertical-align:text-bottom;" border="0" />
					<res:t id="make-pdf"/>
				</a>
				<a href="#" onClick="openHelp();">
					<img src="res/base/icon_help.gif" style="vertical-align:text-bottom;" border="0" />
					<res:t id="help"/>
				</a>
				
			</c:if>
</td>			


</tr>
</table>
</div>	

	<script language="javascript">
		/* Initialize the page number status field */
		setPageNumberStatusPage(<%= currentPage%>,<%=pagesCount%>);
		/* Initialize the page numbers combo */
		setPagesComboBox(<%=pagesCount%>);
		/* Initialize the data filter warning */
		setDataFilteredWarning(<%=pgd.isDataFiltered()%>);
	</script>

		<%
				// Write the blox out

				rBlox.write(out);
			} catch (Exception e) {
				Throwable msg = ErrorBlox.getRootCause(e);
				Log.fatalException(e);
			}      
		 %>		
		</c:when>

		<%-- ------------------------ --%>
		<%--       Chart Blox         --%>
		<%-- ------------------------ --%>

		<c:when  test="${bloxtype == 'CHART'}">
			<%
					ChartBloxBean chartBloxBean = (ChartBloxBean) blox;
			%>
				<h2>
					<img 
						id='img_chartdiv' 
						src="res/base/tree_open.gif" 
						style="vertical-align:middle;" 
						border="0"
						onClick="expandCollapseTree('chartdiv'); return false;" />
					<res:t id='chart'/> <i><%=chartBloxBean.getTranslatedTitle()%></i>
				</h2> 
				
				<div id='chartdiv'>
					<div class="pagingBar" style="margin-bottom: 5px;">
					<c:if test="${!isPrintRenderer}">
						<form name="chartTypeForm">
							<table cellspacing="5" cellpadding="0">
								<tr>
									<td>
										<res:t id='chart-type'/>
									</td>
									<td>
										<input 
											type="radio"
											name="chartSelect" 
											value="Bar"
											onClick='setChartType("<%=chartBloxBean.getId()%>",value);'
											style="vertical-align: text-bottom;" />
										<img src="res/chart_bar.gif" border="0" style="vertical-align: text-bottom;"/>
										<res:t id='chart-bar' />

									</td>
								</tr>
								<tr>
									<td></td>
									<td valign="middle">
										<input
											type="radio"
											 name="chartSelect" 
											value="Pie"
											onClick='setChartType("<%=chartBloxBean.getId()%>",value);'
											style="vertical-align: text-bottom;" />
										<img src="res/chart_pie.gif" border="0" style="vertical-align: text-bottom;"/>
										<res:t id='chart-pie' />
	
									</td>
								</tr>
							</table>
						</form>
					</c:if>
					</div>
					<%
					try {
			
						// Check if blox with given id already exists....
						String bID = chartBloxBean.getId();			
						ChartBlox cBlox = (ChartBlox) bContext.getBlox(bID);
				
						// If blox haven't been yet initialized, create it
						if (cBlox == null) {
							cBlox = chartBloxBean.createChartBlox(bContext);
						} else {
							// Reload the ChartBlox (defect 74535)
							cBlox.getDataBlox().refresh();
						}
				
						cBlox.render(bloxRequest, out);
					} catch (Exception e) {
						Log.fatalException(e);
					}
					 %>
			 	</div>
		</c:when>
	
	</c:choose>

</c:forEach>

</body>
</html>