<%@ page language="java" contentType="text/html; charset=UTF-8"%>
<%@ taglib uri="bloxreporttld" prefix="bloxreport" %>

<%@ page import="com.alphablox.blox.*" %>
<%@ page import="com.ibm.scm.reports.*" %>
<%@ page import="com.ibm.scm.reports.sql.*" %>
<%@ page import="com.ibm.scm.reports.filtering.*" %>
<%@ page import="java.util.*" %>

<!--
  --
  -- @(#)18  1.2  src/web/reports/setQueryDynamically.jsp, hc.report, scm5110, 060628a  6/28/06  02:23:47   
  --
  -- Licensed Materials - Property of IBM
  -- 5724-F82
  -- (C) Copyright IBM Corp.  2003, 2006
  -- All Rights Reserved
  -- US Government Users Restricted Rights - Use, duplication or 
  -- disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
  --
-->


<%@ taglib uri="resourcetagstld" prefix="res" %>
<res:checkUser />

<%-- 

This page is used for dynamically changing query parameters. It should be
inside an IFRAME in page containg the relational report blox (so we can call
the JavaScript functions that refresh the report).

--%>


<% 
	// Get the report description information
	String reportName = request.getParameter("reportName"); 
	String pagedSQLBloxName = request.getParameter("pagedBloxName");
	
	// Get the action type:
	String pageNumber = request.getParameter("pageNumber"); // change page number?
	String rowsPerPage = request.getParameter("rowsPerPage"); // change number of rows per page?
	String updateFilter = request.getParameter("updateFilter");    // update filter ?
	
	// Get the associated context and SQLDataBlox
	BloxContext bContext = BloxContextFactory.getBloxContext(request, response);
	ReportBlox rBlox = (ReportBlox) bContext.getBlox(reportName);
	PagedSQLDataBlox pBlox = (PagedSQLDataBlox) bContext.getBlox(pagedSQLBloxName);

	// Set default values
	int lastPageNumber=1;
	int newPageNumber=1;


	////////////////////////////////////////
	// Do we want to change the page number ?
	if (pageNumber != null) {
		int curPage= pBlox.getCurrentPage();
		lastPageNumber = pBlox.getLastPageNumber();
		
		// OK. So - where do we wanna to go today?
		if (pageNumber.trim().equalsIgnoreCase("prev")) { 			// forward
			newPageNumber = curPage-1;
		} else if (pageNumber.trim().equalsIgnoreCase("next")) { 	// backward
			newPageNumber = curPage+1;
		} else { 																			// into specific place
			try {
				newPageNumber = Integer.parseInt(pageNumber);
			} catch (Exception e) {
				newPageNumber = 1; // cannot parse the page number ?
			}
		}

		// Is page number valid?
		if (newPageNumber > lastPageNumber)
			newPageNumber = lastPageNumber;
		if (newPageNumber < 1)
			newPageNumber = 1;
	} 
	else
	////////////////////////////////////////
	// Do we want to change number of rows per page ?
	if (rowsPerPage != null) {
		int curPage= pBlox.getCurrentPage();
		int curStartingRow = (curPage-1)*pBlox.getRowsPerPage();
		
		pBlox.setRowsPerPage(Integer.parseInt(rowsPerPage));
		newPageNumber = 1;
		if (pBlox.getRowsPerPage() != 0 && curStartingRow >= 0) {
			newPageNumber = (int) Math.ceil(curStartingRow/pBlox.getRowsPerPage()) + 1;
		}
	
		lastPageNumber = pBlox.getLastPageNumber();

		// Is page number valid?
		if (newPageNumber > lastPageNumber)
			newPageNumber = lastPageNumber;
		if (newPageNumber < 1)
			newPageNumber = 1;
	} 
	else
	////////////////////////////////////////
	// Do we want to change (or set) data filter ?
	if (updateFilter != null && updateFilter.equalsIgnoreCase("true")) 
	{
		// Clear all previously set filter options (ie. set no filtering)
		ReportBloxBean rbb = (ReportBloxBean) pBlox.getBloxBean();
		rbb.clearFilterOptionsValues();
		
		// Get and then iterate the page request parameters
		Map params = request.getParameterMap();
		for (Iterator it = params.keySet().iterator(); it.hasNext(); ) {
			String key = it.next().toString();
			
			////////////////
			// String (ie. search) query data is provided in following form:
			// filterquery_[FilterOption_id]
			// For example:
			// filterquery_1234
			//
			if (key.startsWith("filterquery_")) {
				try {
					String[] els = key.split("_",2);
					if (els.length == 2) { // seems to be right data
						String filterID = els[1];    // filterID is second
					
						String valStr = request.getParameter(key);
						QueryFilterOption qfo = (QueryFilterOption) rbb.getFilterById(Integer.parseInt(filterID));
						qfo.selectValue(valStr);
					}
				} catch (Exception e) {} // ignore the request with invalid data
			
			}
			
			////////////////
			//
			// Values filter data are provided in following form:
			// filter_[FilterOption_id]_[value]
			// For example:
			// filter_1234_Some value
			//
			// Which means that FilterOption with id (id) should show only
			// rows containg value (value).

			if (key.startsWith("filter_")) {
				// Split the request data into three strings:
				try {
					String[] els = key.split("_",3);
					if (els.length == 3) { // seems to be right data
						String filterID = els[1];    // filterID is second
						String val = els[2];          // value is third
					
						String valStr = request.getParameter(key);

						// Get FilterOption basing on its ID
						ValuesFilterOption vo = (ValuesFilterOption) rbb.getFilterById(Integer.parseInt(filterID));
					
						// Do we want to filter-in or filter-out ?
						boolean isOn = false;
						if (valStr != null && valStr.equalsIgnoreCase("on")) 
							isOn = true;
						
						// Set the filter to filter specific value
						vo.selectValue(val, isOn);
					}
				} catch (Exception e) {} // ignore the request with invalid data
			}
			
		}
		
		// It's quite possible that after applying the filters, last page number has changed
		lastPageNumber = pBlox.getLastPageNumber();            
	}

	// Update the currently set members group order (from the ReportBlox object - the input is recursively traversed !)
	pBlox.setSortingOrderByInput(rBlox.getInput());
	
	// Set the appropriate page number
	pBlox.setCurrentPage(newPageNumber);
	
	// Execute the query
	pBlox.execute();
%>

<%-- Basically, an empty page that just refreshes the "right" page--%>
<html>
<head> 
	<meta http-equiv="Content-Type" content="text/html; charset=UTF-8">
</head> 
<body> 
<script> 
	<%-- Refresh the data. --%>
	<%-- Report itself:        --%>
	parent.refresh( "<%=reportName%>" );
	<%-- Status bar:          --%>
	parent.setPageNumberStatusPage(<%=newPageNumber%>,<%=lastPageNumber%>);
	<%-- Filtering information: --%>
	parent.setDataFilteredWarning(<%=pBlox.isDataFiltered()%>);
</script>
</body>
</hml>